"use strict";

exports.__esModule = true;
exports.default = createCreateCreateGenericTypeMetadata;
function createCreateCreateGenericTypeMetadata(t, externalTypeNames, internalTypes, reservedGenerics) {
    return function createCreateGenericTypeMetadata(createObjectTypeMetadata) {
        return function createGenericTypeMetadata(annotation) {
            var id = annotation.id;
            if (reservedGenerics.has(id.name)) {
                return createGenericTypeMetadata(annotation.typeParameters.params[0]);
            }
            var internalType = internalTypes.get(id.name);
            if (internalType) {
                return createObjectTypeMetadata(internalType);
            }
            var imported = externalTypeNames.get(id.name);
            if (imported) {
                id = t.stringLiteral(imported);
            }
            return id;
        };
    };
}
//# sourceMappingURL=createCreateCreateGenericTypeMetadata.js.map